aboutsummaryrefslogtreecommitdiff
path: root/gen/prop/scf
diff options
context:
space:
mode:
Diffstat (limited to 'gen/prop/scf')
-rwxr-xr-xgen/prop/scf59
1 files changed, 59 insertions, 0 deletions
diff --git a/gen/prop/scf b/gen/prop/scf
new file mode 100755
index 0000000..c2a2b9d
--- /dev/null
+++ b/gen/prop/scf
@@ -0,0 +1,59 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_scf.c
+
+gawk '
+BEGIN {
+ FS = "[ ;]+"
+
+ print "/* This file is autogenerated by gen/prop/scf; DO NOT EDIT. */"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+$0 !~ /^#/ && $2 ~ /[CS]/ {
+ map[strtonum("0X" $1)] = strtonum("0X" $3)
+}
+
+END {
+ print "static constexpr rune lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "0x%03X,%s", map[i] ? map[i] : i, i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune k, v;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (!map[i])
+ continue
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X)},\n", i, map[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH_KV(rune, lookup, ch)"
+ print ""
+ print "rune"
+ print "uprop_get_scf(rune ch, bool az_or_tr)"
+ print "{"
+ print "\tif (az_or_tr) {"
+ print "\t\tif (ch == \x27I\x27)"
+ print "\t\t\treturn U\x27ı\x27;"
+ print "\t\tif (ch == U\x27İ\x27)"
+ print "\t\t\treturn \x27i\x27;"
+ print "\t}"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup_kv(ch);"
+ print "}"
+}
+' data/CaseFolding